#include <SoftwareSerial.h>// RX, TX

#include <Servo.h>

#include "ContestRobot.hpp"

Servo PAN, TILT, HELPPIN;


SoftwareSerial BLUETOOTH(BLUETOOTH_RX, BLUETOOTH_TX);

int flag = 0;
int BluetoothData;

void setup() {
  BLUETOOTH.begin(9600);
  BLUETOOTH.println("Bluetooth ready.");

  Serial.begin(57600);
  Serial.println("Program Ready");

  HELPPIN.attach(HELPPIN_SERVO);
  PAN.attach(PAN_SERVO);
  TILT.attach(TILT_SERVO);

  pinMode(RGB_RED, OUTPUT);
  pinMode(RGB_GREEN, OUTPUT);
  pinMode(RGB_BLUE, OUTPUT); 

  pinMode(RIGHT_FORWARD, OUTPUT);
  pinMode(RIGHT_BACKWARD, OUTPUT);
  pinMode(LEFT_FORWARD, OUTPUT);
  pinMode(LEFT_BACKWARD, OUTPUT);

  PAN.writeMicroseconds(1500);
  TILT.writeMicroseconds(1500);
  analogWrite(RIGHT_FORWARD, 0);
  analogWrite(RIGHT_BACKWARD, 0);
  analogWrite(LEFT_FORWARD, 0);
  analogWrite(LEFT_BACKWARD, 0);

  setColor(0, 255, 255);

}

void loop() {

  if (BLUETOOTH.available()) //Read whats coming in through Bluetooth
 {
  BluetoothData=BLUETOOTH.read();
  Serial.print("Incoming from BT:");
  Serial.println(BluetoothData);
 }
 
  if (BluetoothData==49) //Turn Left
 {}
 
 if (BluetoothData==50) //Turn Right
 {}
 
 if (BluetoothData==51) //Turn Up
 {}
 
 if (BluetoothData==52) //Turn Down
 {}
 
 flag=0;
 BluetoothData=0;
 
}

void DriveForward(int speed){
  analogWrite(RIGHT_FORWARD, speed);
  analogWrite(RIGHT_BACKWARD, 0);
  analogWrite(LEFT_FORWARD, speed);
  analogWrite(LEFT_BACKWARD, 0);
}

void DriveBackward(int speed){
  analogWrite(RIGHT_FORWARD, 0);
  analogWrite(RIGHT_BACKWARD, speed);
  analogWrite(LEFT_FORWARD, 0);
  analogWrite(LEFT_BACKWARD, speed);
  }

void TurnLeft(int speed){
  analogWrite(RIGHT_FORWARD, speed);
  analogWrite(RIGHT_BACKWARD, 0);
  analogWrite(LEFT_FORWARD, 0);
  analogWrite(LEFT_BACKWARD, speed);
  }

void TurnRight(int speed){
  analogWrite(RIGHT_FORWARD, 0);
  analogWrite(RIGHT_BACKWARD, speed);
  analogWrite(LEFT_FORWARD, speed);
  analogWrite(LEFT_BACKWARD, 0);
  }
  
void stop(){
  analogWrite(RIGHT_FORWARD, 0);
  analogWrite(RIGHT_BACKWARD, 0);
  analogWrite(LEFT_FORWARD, 0);
  analogWrite(LEFT_BACKWARD, 0);
  }  

  
void setColor(int red, int green, int blue){
  #ifdef COMMON_ANODE
    red = 255 - red;
    green = 255 - green;
    blue = 255 - blue;
  #endif
  analogWrite(RGB_RED, red);
  analogWrite(RGB_GREEN, green);
  analogWrite(RGB_BLUE, blue);  
}



